; ================== internal engine defines

IVERTEXSIZE	equ	16
SIDESIZE	equ	25

SX_VERTEX	equ	4
SY_VERTEX	equ	0
ISX_VERTEX	equ	SX_VERTEX+2
ISY_VERTEX	equ	SY_VERTEX+2
U_VERTEX	equ	8
V_VERTEX	equ	12
U2_VERTEX	equ	16
V2_VERTEX	equ	20
YSIZE		equ	200
H_SIDE		equ	0
X_SIDE		equ	1
DX_SIDE		equ	5
U_SIDE		equ	9
DU_SIDE		equ	13
V_SIDE		equ	17
DV_SIDE		equ	21
U2_SIDE		equ	25
DU2_SIDE	equ	29
V2_SIDE		equ	33
DV2_SIDE	equ	37

; ================== texturemapper

calc_side		proc	near
	pusha
	xor	ecx,ecx
	mov	cx,[bp+ISY_VERTEX]
	sub	cx,[bx+ISY_VERTEX]
	mov	[di],cl
	jz	exit_side
	inc	di

	; calculate initial values and deltas for SX/U/V/U2/V2

rept	5
	add	bx,4
	add	bp,4
	mov	eax,[bx]
	stosd
	mov	eax,[bp]
	sub	eax,[bx]
	cdq
	idiv	ecx
	stosd
endm

exit_side:
	popa
	ret
calc_side	endp

; si=sidea bx=sideb
do_section	proc	near
line_loop:
	cmp	byte ptr [si+H_SIDE],0
	je	line_loop_end
	cmp	byte ptr [bx+H_SIDE],0
	je	line_loop_end
	cmp	skip_y,0
	jl	end_line
	cmp	skip_y,YSIZE
	jge	line_loop_end

	mov	cx,[bx+X_SIDE+2]
	mov	bp,[si+X_SIDE+2]
	cmp	cx,bp
	je	end_line
	jg	do_line
	xchg	si,bx
	jmp	line_loop
do_line:
	pusha
	sub	cx,bp

;	mov	eax,[bx+U_SIDE]
;	sub	eax,[si+U_SIDE]
;	cdq
;	idiv	ecx
;	mov	du,ax
;	mov	eax,[bx+V_SIDE]
;	sub	eax,[si+V_SIDE]
;	cdq
;	idiv	ecx
;	mov	dv,ax

	add	di,word ptr [si+X_SIDE+2]

	mov	bx,word ptr [si+U_SIDE]
	mov	ax,word ptr [si+V_SIDE]
	mov	su,bx
	mov	sv,ax
	mov	bx,word ptr [si+U2_SIDE]
	mov	ax,word ptr [si+V2_SIDE]
	mov	su2,bx
	mov	sv2,ax

	cmp	bp,0
	jge	no_left_clip
	sub	di,bp
	add	cx,bp

	mov	ax,du
	imul	bp
	sub	su,ax
	mov	ax,dv
	imul	bp
	sub	sv,ax
	mov	ax,du2
	imul	bp
	sub	su2,ax
	mov	ax,dv2
	imul	bp
	sub	sv2,ax
no_left_clip:
	add	bp,cx
	sub	bp,319
	jl	do_inner
	sub	cx,bp
do_inner:

	cmp	cx,0
	jle	end_inner

;	mov	ax,texMap
;	or	ax,ax
;	jz	do_inner2
;	mov	fs,ax

	mov	ax,phongMapSeg
	mov	fs,ax

	inc	cx
	push	cx di
	mov	ax,0505h
	org	$-2
su	dw	?
	mov	dx,0505h
	org	$-2
sv	dw	?
inner:
	mov	bl,ah
	mov	bh,dh
	mov	bl,fs:[bx]
;	shl	bl,5
	mov	gs:[di],bl
	inc	di
	add	ax,0505h
	org	$-2
du	dw	?
	add	dx,0505h
	org	$-2
dv	dw	?
	loop	inner
	pop	di cx

do_inner2:
;jmp	end_inner	; kludge!
;	mov	ax,envMap
;	or	ax,ax
;	jz	end_inner
;	mov	fs,ax
	mov	ax,tex2
	mov	fs,ax

	mov	ax,0505h
	org	$-2
su2	dw	?
	mov	dx,0505h
	org	$-2
sv2	dw	?
inner2:
	mov	bl,ah
	mov	bh,dh
	mov	bl,fs:[bx]
	add	gs:[di],bl
	inc	di
	add	ax,0505h
	org	$-2
du2	dw	?
	add	dx,0505h
	org	$-2
dv2	dw	?
	loop	inner2

end_inner:
	popa

end_line:
	dec	byte ptr [si+H_SIDE]
	dec	byte ptr [bx+H_SIDE]
	inc	skip_y
	add	di,320

	; slide X/U/V/V2 on both sides

	pusha
	inc	si
	inc	bx
rept	5
	mov	eax,[si+4]
	add	[si],eax
	add	si,8
	mov	eax,[bx+4]
	add	[bx],eax
	add	bx,8
endm
	popa

	jmp	line_loop
line_loop_end:
	ret
do_section	endp

drawTexTri	proc	near
	push	cs
	pop	es

	mov	ax,[bx+ISY_VERTEX]
	cmp	ax,[si+ISY_VERTEX]
	jle	ysort_1
	xchg	bx,si
ysort_1:
	mov	ax,[bx+ISY_VERTEX]
	cmp	ax,[bp+ISY_VERTEX]
	jle	ysort_2
	xchg	bx,bp
ysort_2:
	mov	ax,[si+ISY_VERTEX]
	cmp	ax,[bp+ISY_VERTEX]
	jle	ysort_3
	xchg	si,bp
ysort_3:					; bx si bp - 1 2 3

	pusha
	mov	di,offset side1
	call	calc_side			; bx si bp - 1 2 3
	mov	di,offset side2
	xchg	si,bp
	call	calc_side			; bx si bp - 1 3 2
	mov	di,offset side3
	xchg	bx,bp
	xchg	si,bp
	call	calc_side			; bx si bp - 2 1 3
	popa

	mov	di,[bx+ISY_VERTEX]
	mov	skip_y,di
	mov	bx,di
	shl	di,8
	shl	bx,6
	add	di,bx

	xor	ebx,ebx
	mov	bl,side2h

	mov	eax,side1dx
	imul	ebx
	add	eax,side1x
	sub	eax,[si+SX_VERTEX]		; side2x might be unset
	mov	ecx,eax
	sar	ecx,16
	jz	drawTexTri_exit

	mov	eax,side1du
	imul	ebx
	add	eax,side1u
	sub	eax,[si+U_VERTEX]		; side2u might be unset
	cdq
	idiv	ecx
	mov	du,ax

	mov	eax,side1dv
	imul	ebx
	add	eax,side1v
	sub	eax,[si+V_VERTEX]		; side2v might be unset
	cdq
	idiv	ecx
	mov	dv,ax

	mov	eax,side1du2
	imul	ebx
	add	eax,side1u2
	sub	eax,[si+U2_VERTEX]		; side2u2 might be unset
	cdq
	idiv	ecx
	mov	du2,ax

	mov	eax,side1dv2
	imul	ebx
	add	eax,side1v2
	sub	eax,[si+V2_VERTEX]		; side2v2 might be unset
	cdq
	idiv	ecx
	mov	dv2,ax

	mov	ax,screenBuf
	mov	gs,ax

	mov	si,offset side1
	mov	bx,offset side2
	call	do_section
	mov	si,offset side1
	mov	bx,offset side3
	call	do_section

drawTexTri_exit:
	ret
drawTexTri	endp

; ================== calculating rotation matrix

makeRotMatrix	proc	near
	mov	di,offset matrix
	xor	ax,ax
	mov	cx,18
	rep	stosw
	fild	frame
	fidiv	i3
	fmul	fPi180
	fsincos
	fst	dword ptr matrix[0]
	fstp	dword ptr matrix[32]
	fst	dword ptr matrix[8]
	fchs
	fstp	dword ptr matrix[24]
	fld1
	fstp	dword ptr matrix[16]
	ret
makeRotMatrix	endp

; ================== prepare floating point values for rendering

rotateVertex	proc	near
	fld	dword ptr [di]
	fmul	dword ptr [si]
	fld	dword ptr [di+4]
	fmul	dword ptr [si+4]
	fadd
	fld	dword ptr [di+8]
	fmul	dword ptr [si+8]
	fadd

	fld	dword ptr [di+12]
	fmul	dword ptr [si]
	fld	dword ptr [di+16]
	fmul	dword ptr [si+4]
	fadd
	fld	dword ptr [di+20]
	fmul	dword ptr [si+8]
	fadd

	fld	dword ptr [di+24]
	fmul	dword ptr [si]
	fld	dword ptr [di+28]
	fmul	dword ptr [si+4]
	fadd
	fld	dword ptr [di+32]
	fmul	dword ptr [si+8]
	fadd
	fstp	dword ptr [si+8]
	fstp	dword ptr [si+4]
	fstp	dword ptr [si]

	ret
rotateVertex	endp

prepareScene	proc	near
	mov	cx,numVerts
	mov	si,offset fverts
	mov	di,offset matrix
rotate_vertex:
	call	rotateVertex
	add	si,12
	call	rotateVertex

	fld	dword ptr [si]
	fmul	st(0),st(0)
	fld	dword ptr [si+4]
	fmul	st(0),st(0)
	fld	dword ptr [si+8]
	fmul	st(0),st(0)
	fadd
	fadd
	fsqrt
	fld	st(0)

	fld	dword ptr [si]
	fdivr
	fld1
	fadd
	fimul	UVscale
	fistp	dword ptr [si]
	fld	dword ptr [si+4]
	fdivr
	fld1
	fadd
	fimul	UVscale
	fistp	dword ptr [si+4]

	add	si,20
	loop	rotate_vertex

	mov	cx,numFaces
	mov	si,offset faces
	mov	di,offset face_z
calc_mid_z:
	lodsw
	mov	bx,32
	mul	bx
	mov	bx,ax
	fld	dword ptr fverts[bx+8]
	lodsw
	mov	bx,32
	mul	bx
	mov	bx,ax
	fld	dword ptr fverts[bx+8]
	lodsw
	mov	bx,32
	mul	bx
	mov	bx,ax
	fld	dword ptr fverts[bx+8]
	fadd
	fadd
	fimul	iFix1
	fistp	dword ptr [di]
	add	di,4
	loop	calc_mid_z

	mov	cx,numVerts
	mov	si,offset fverts
	mov	di,offset verts
project_vertex:
	fld	dword ptr [si+8]
	fiadd	i8
	fidivr	i320
	fld	st(0)
	fmul	dword ptr [si]
	fiadd	i160
	fimul	iFix1
	fistp	dword ptr [di+4]
	fmul	dword ptr [si+4]
	fisubr	i100
	fimul	iFix1
	fistp	dword ptr [di]
;	add	si,12
;	add	di,8
;	movsd
;	movsd
;	add	si,12
;	add	di,16
	add	si,12
	add	di,8
	movsd
	movsd
	add	si,4
	movsd
	movsd
	add	di,8
	loop	project_vertex

	ret
prepareScene	endp

; ================== mesh rendering

sortfaces_ proc near
  aend equ word ptr [bp+6]
  start equ word ptr [bp+4]

  push bp
  mov bp,sp

  mov si,start
  mov di,aend

  mov bx,di
  sub bx,si
  shr bx,1
  and bx,not 1
  mov bx,[si+bx]
  shl bx,2
  mov ecx,face_z[bx]

@@lp:
  @@lpesi:
      mov bx,[si]
      shl bx,2
      cmp face_z[bx],ecx
      jle @@lpesib
      add si,2
      cmp si,aend
      jb @@lpesi
  @@lpesib:
  @@lpedi:
      mov bx,[di]
      shl bx,2
      cmp face_z[bx],ecx
      jge @@lpedib
      sub di,2
      cmp di,start
      ja @@lpedi
  @@lpedib:
    cmp si,di
    ja @@fini

    push bp
    mov bx,[si]
    shl bx,2
    mov bp,[di]
    shl bp,2
    mov eax,face_z[bx]
    xchg eax,face_z[bp]
    mov face_z[bp],eax
    pop bp

    mov ax,[si]
    xchg ax,[di]
    mov [si],ax
    add si,2
    sub di,2
    jmp @@lp

@@fini:
  cmp di,start
  jbe @@nosortedi
    push si
    push di
    push start
    call sortfaces_
    pop si
@@nosortedi:
  cmp si,aend
  jae @@nosortesi
    push aend
    push si
    call sortfaces_
@@nosortesi:
@@done:
  pop bp
  ret 4
endp

drawMesh	proc	near
	mov	fs,ax
	push	cs
	pop	es
	mov	cx,numFaces
	or	cx,cx
	jz	no_scene
	xor	ax,ax
	mov	di,offset order
	push	di
setorder:
	stosw
	inc	ax
	loop	setorder
	pop	si
	sub	di,2
	push	di si
	call	sortfaces_

	mov	cx,numFaces
	xor	bx,bx
draw_face:
	pusha
	mov	bx,order[bx]
	mov	ax,bx
	add	ax,ax
	add	bx,ax
	add	bx,bx
	add	bx,offset faces
	mov	si,[bx+2]
	mov	bp,[bx+4]
	mov	bx,[bx]
	shl	bx,5
	shl	si,5
	shl	bp,5
	add	bx,offset verts
	add	si,offset verts
	add	bp,offset verts
	call	drawTexTri
	popa
	inc	bx
	inc	bx
	loop	draw_face
no_scene:
	ret
drawMesh	endp