; ================== draw one frame

frameKnot	proc	near
	mov	bp,offset knotPosDir
	mov	si,offset m_knot
	jmp	frameTube
frameKnot	endp

frameBraid	proc	near
	mov	bp,offset braidPosDir
	mov	si,offset m_braid
;	jmp	frameTube
frameBraid	endp

frameTube	proc	near
	push	si
	push	cs
	pop	es
	call	makeRotMatrix
	call	makeMesh
	call	prepareScene
	call	drawMesh
	pop	si
	call	printStrBeg
	ret
frameTube	endp

; ================== plasma texture

plasmarand proc
  push eax
  mov eax,015A4E35h
  imul eax,ebp
  inc eax
  mov ebp,eax
  pop eax
  mov ecx,ebp
  sar ecx,16
  ret
endp

plasmaput proc
  imul ecx,edi
  sar ecx,17
  add eax,ecx
  add eax,2
  sar eax,2
  jns @@nbelow1
    xor eax,eax
@@nbelow1:
  cmp eax,esi
  jb @@nabove1
    mov eax,esi
@@nabove1:
  mov [bx],al
  ret
endp

public txPlasmaMap_
txPlasmaMap_ proc
  push ebp
  mov ebp,eax
  mov eax,-1
  shl eax,cl
  not eax
  mov esi,eax
  call plasmarand
  and ecx,esi
  mov byte ptr [bx],cl
  mov edx,0080h
@@l1:
  @@l2a:
    @@l2b:
        movzx eax,byte ptr [bx]
        add bl,dh
        add al,[bx]
        adc ah,0
        add bh,dh
        add al,[bx]
        adc ah,0
        sub bl,dh
        add al,[bx]
        adc ah,0
        sub bh,dl
        add bl,dl
        call plasmarand
	push eax
	mov eax,ecx
	add eax,ecx
	add ecx,eax
	pop eax
        call plasmaput
        sub bh,dl
        add bl,dl
      jnz @@l2b
    add bh,dh
    jnz @@l2a

  @@l3a:
    @@l3b:
        movzx eax,byte ptr [bx]
        add bh,dh
        add al,[bx]
        adc ah,0
        sub bh,dl
        add bl,dl
        add al,[bx]
        adc ah,0
        sub bl,dh
        add al,[bx]
        adc ah,0
        add bl,dl
        call plasmarand
        add ecx,ecx
        call plasmaput
        sub bh,dl

        movzx eax,byte ptr [bx]
        add bl,dh
        add al,[bx]
        adc ah,0
        sub bl,dl
        add bh,dl
        add al,[bx]
        adc ah,0
        sub bh,dh
        add al,[bx]
        adc ah,0
        add bh,dl
        call plasmarand
        add ecx,ecx
        call plasmaput
        add bl,dl
      jnz @@l3b
    add bh,dh
    jnz @@l3a

    sar edi,1
    mov dh,dl
    shr dl,1
  jnz @@l1
  pop ebp

  push ds
  pop es
  xor cx,cx
  xor si,si
  xor di,di
@@plasma_lighten:
  lodsb
  shl al,5
  stosb
  loop @@plasma_lighten

  ret
endp

; ================== mesh generation

vecmul		proc	near
	fld	dword ptr [bx+4]
	fmul	dword ptr [si+8]
	fld	dword ptr [bx+8]
	fmul	dword ptr [si+4]
	fsub
	fst	dword ptr [di]
	fmul	st(0),st(0)

	fld	dword ptr [bx+8]
	fmul	dword ptr [si+0]
	fld	dword ptr [bx+0]
	fmul	dword ptr [si+8]
	fsub
	fst	dword ptr [di+4]
	fmul	st(0),st(0)

	fld	dword ptr [bx+0]
	fmul	dword ptr [si+4]
	fld	dword ptr [bx+4]
	fmul	dword ptr [si+0]
	fsub
	fst	dword ptr [di+8]
	fmul	st(0),st(0)

	fadd
	fadd
	fsqrt
	fdivr	fTubeRadius
	fld	st(0)
	fld	st(0)
	fmul	dword ptr [di]
	fstp	dword ptr [di]
	fmul	dword ptr [di+4]
	fstp	dword ptr [di+4]
	fmul	dword ptr [di+8]
	fstp	dword ptr [di+8]
	ret
vecmul		endp

knotPosDir	proc	near
	fmul	fPiRing		; stack: t

	fld	st(0)
	fld	st(0)
	fcos
	fxch	st(1)
	fadd	st(0),st(0)
	fcos			; stack: cos(2t) cos(t) t
	fmul	f18
	fld	st(0)
	fsub	st(0),st(2)
	fstp	posx
	fadd	st(0),st(0)
	faddp	st(1)
	fstp	diry		; stack: t
	fld	st(0)
	fld	st(0)
	fsin
	fxch	st(1)
	fadd	st(0),st(0)
	fsin			; stack: sin(2t) sin(t) t
	fmul	f18
	fld	st(0)
	fadd	st(0),st(2)
	fstp	posy
	fadd	st(0),st(0)
	fsub
	fstp	dirx		; stack: t
	fimul	i3
	fld	st(0)
	fsin
	fmul	f08
	fstp	posz
	fcos
	fmul	f24
	fstp	dirz
	ret
knotPosDir	endp

braidPosDir	proc	near
	fmul	fPiRing		; stack: t
	fld	st(0)

	fimul	i3
	fsincos
	fstp	c3
	fstp	s3

	fimul	iRounds
	fild	frame
	fidiv	i3
	fmul	fPiRing
	fadd
	fld	st(0)
	fsincos
	fmul	f07
	fstp	c2
	fmul	f07
	fstp	s2

	fadd	st(0),st(0)
	fsincos
	fmul	f07
	fstp	c1
	fmul	f07
	fstp	s1

	fld	s1
	fadd	f25
	fmul	c3
	fstp	posx

	fld	s1
	fadd	f25
	fmul	s3
	fstp	posy

	fld	s2
	fstp	posz

	fld	c2
	fimul	iRounds
	fstp	dirz

	fild	i3
	fmul	posy
	fld	c1
	fmul	c3
	fimul	iRounds
	fadd	st(0),st(0)
	fsubr
	fstp	dirx

	fild	i3
	fmul	posx
	fld	c1
	fmul	s3
	fimul	iRounds
	fadd	st(0),st(0)
	fadd
	fstp	diry

	ret
braidPosDir	endp

putBoundVert	proc	near
	push	ax
	cmp	ax,RINGSEGS*CYLNSEGS
	jb	no_fix
	sub	ax,RINGSEGS*CYLNSEGS
no_fix:
	stosw
	pop	ax
	ret
putBoundVert	endp

makeMesh	proc	near
	mov	cx,RINGSEGS
	mov	di,offset fverts
	xor	bx,bx
makeMesh_ring:
	mov	ax,RINGSEGS
	sub	ax,cx
	mov	iX,ax
	fild	iX
	call	bp

	pusha
	mov	bx,offset pos
	mov	si,offset dir
	mov	di,offset p1
	call	vecmul
	mov	bx,di
	mov	di,offset p2
	call	vecmul
	popa

	mov	dx,CYLNSEGS
makeMesh_seg:
	push	dx

	mov	ax,CYLNSEGS
	sub	ax,dx
	mov	iY,ax

	fild	iY
	fmul	fPiCyln		; stack: a
	fsincos			; stack: cos(a) sin(a)

	fld	p2x
	fmul	st(0),st(2)
	fld	p1x
	fmul	st(0),st(2)
	fadd
	fst	dword ptr [di+12]
	fadd	posx
	fstp	dword ptr [di]

	fld	p2y
	fmul	st(0),st(2)
	fld	p1y
	fmul	st(0),st(2)
	fadd
	fst	dword ptr [di+16]
	fadd	posy
	fstp	dword ptr [di+4]

	fld	p2z
	fmul	st(0),st(2)
	fld	p1z
	fmul	st(0),st(2)
	fadd
	fst	dword ptr [di+20]
	fadd	posz
	fstp	dword ptr [di+8]

	fstp	tmpf		; cleanup fpu stack
	fstp	tmpf

	fild	iY
	fidiv	iCyln
	fimul	UVscale
	fadd	st(0),st(0)
	fistp	dword ptr [dword ptr di+24]
	fild	iX
	fidiv	iRing
	fimul	UVscale
	fadd	st(0),st(0)
	fadd	st(0),st(0)
	fistp	dword ptr [dword ptr di+28]

	add	di,32
	inc	bx
	pop	dx
	dec	dx
	jnz	makeMesh_seg
	loop	makeMesh_ring

	mov	numVerts,bx

	mov	di,offset faces
	xor	ax,ax
	mov	cx,RINGSEGS
makeMesh_facering:
	mov	bx,CYLNSEGS-1
makeMesh_facecyln:
	push	ax
	stosw
	inc	ax
	stosw
	add	ax,CYLNSEGS
	call	putBoundVert
	pop	ax
	push	ax
	stosw
	add	ax,CYLNSEGS
	call	putBoundVert
	inc	ax
	call	putBoundVert
	pop	ax
	inc	ax
	dec	bx
	jnz	makeMesh_facecyln
	stosw
	sub	ax,CYLNSEGS-1
	stosw
	add	ax,CYLNSEGS
	call	putBoundVert
	call	putBoundVert
	add	ax,CYLNSEGS-1
	call	putBoundVert
	sub	ax,CYLNSEGS
	stosw
	inc	ax
	loop	makeMesh_facering

	add	ax,ax
	mov	numFaces,ax

	ret
makeMesh	endp