; ================== table decompression

rotate_bits	proc	near
	mov	ah,al
	and	al,077h
	shl	al,1
	and	ah,088h
	shr	ah,3
	add	al,ah
	xor	ah,ah
	ret
rotate_bits	endp

rotate_once	proc	near
	mov	si,cx
	mov	di,ax
	shl	si,4
	shl	di,4
;	add	si,offset triTable
;	add	di,offset triTable
	mov	bx,offset triTable
	lea	si,[bx+si]
	lea	di,[bx+di]
	mov	bp,15
	xor	bx,bx
rotate_one:
	mov	bl,[si+bp]
	mov	dl,rotTrans[bx]
	mov	[di+bp],dl
	dec	bp
	jns	rotate_one
	ret
rotate_once	endp

initTables	proc
	push	cs
	pop	es
	mov	si,offset triTablePacked
	mov	di,offset triTable
	push	di
	mov	al,0Fh
	mov	cx,4096
	rep	stosb
	pop	di

	xor	bx,bx
	xor	bp,bp
unp_byte:
	mov	al,[si]
	add	si,bp
	xor	bp,1
	jz	low_nibble
	shr	al,4
low_nibble:
	and	al,0Fh
	cmp	al,0Eh
	je	unp_done
	cmp	al,0Fh
	je	nib_eoln
	mov	[di+bx],al
	inc	bx
	jmp	nib_done
nib_eoln:
	and	bx,0FFF0h
	add	bx,16
nib_done:
	jmp	unp_byte
unp_done:

;	mov	si,offset edgeTablePacked
;	mov	di,offset edgeTable
;	xor	bp,bp
;	mov	cx,64
;unpack_edge:
;	movsb
;	call	get_nibble
;	stosb
;	call	get_nibble
;	movsb
;	stosb
;	loop	unpack_edge
;
;	mov	si,offset edgeTable+256
;	mov	di,si
;	mov	cx,128
;copy_edge:
;	dec	si
;	dec	si
;	mov	ax,[si]
;	stosw
;	loop	copy_edge

	xor	cx,cx
rotate_filler:
	push	cx
	mov	al,cl
	call	rotate_bits
	cmp	al,cl
	je	no_rotate_fill
	call	rotate_once
	mov	cx,ax
	call	rotate_bits
	call	rotate_once
	mov	cx,ax
	call	rotate_bits
	call	rotate_once
no_rotate_fill:
	pop	cx
	inc	cl
	jnz	rotate_filler
	ret
initTables	endp

; ================== rendering environment map for phong shading

makePhongMap	proc	near
	mov	ax,phongMapSeg
	mov	es,ax
	mov	bx,0100h
	xor	di,di
phongMap_yloop:
	mov	iY,bx
	mov	cx,0100h
phongMap_xloop:
	mov	iX,cx

	fild	iY
	fdiv	fPhongDiv
	fsin
	fild	iX
	fdiv	fPhongDiv
	fsin
	fmul
	fmul	st(0),st(0)
	fmul	st(0),st(0)
	fimul	spotLite
	fistp	tmp16

	mov	ax,tmp16
	add	al,AMBIENT
;	mov	dl,cl
;	xor	dl,bl
;	and	dl,03Fh
;	shr	dl,2
;	add	bl,dl
;	cmp	bl,03Fh
;	jbe	no_bl_clip
;	mov	bl,03Fh
;no_bl_clip:
;	shl	bl,2
;	mov	es:[di],bl

;	and	dl,03Fh
;	add	al,dl
;	jnc	no_al_clip
;	mov	al,0FFh
;no_al_clip:
	stosb
	loop	phongMap_xloop
	dec	bx
	jnz	phongMap_yloop
	ret
makePhongMap	endp

; ================== routine and macro for vertex interpolation

interp	macro	v1,v2,v3,v4,v5,v6,v7
	mov	cl,v7
	mov	bx,4*(v1*YGRID*ZGRID+v2*ZGRID+v3)
	mov	bp,4*(v4*YGRID*ZGRID+v5*ZGRID+v6)
	call	interpolate
endm

; [si]=grid [di]=vertlist
interpolate	proc	near
	rcr	ax,1
	jnc	no_interpolate
	pusha		; adjust variables according to passed flags
	xor	ch,ch
	mov	ax,cx
	mov	bx,cx
	mov	dx,cx
	mov	si,cx
	mov	di,cx
	shr	ax,5
	shr	bx,4
	shr	cx,3
	shr	dx,2
	shr	si,1
	and	ax,1	; v1
	and	bx,1	; v2
	and	cx,1	; v3
	and	dx,1	; v4
	and	si,1	; v5
	and	di,1	; v6
	sub	dx,ax
	sub	si,bx
	sub	di,cx
	mov	Xd,dx
	mov	Yd,si
	mov	Zd,di
	add	ax,iX
	add	bx,iY
	add	cx,iZ
	mov	Xa,ax
	mov	Ya,bx
	mov	Za,cx
	popa

	fld	dword ptr [si+bp]
	fsub	dword ptr [si+bx]
	fld	fIsoLevel
	fsub	dword ptr [si+bx]
	fdivr				; st0=mu

	fild	Zd
	fmul	st(0),st(1)
	fiadd	Za
	fild	iFix1
	fmul	st(0),st(1)
	fistp	dword ptr [di+16]

	fiadd	i20
	fidivr	i320

	fild	Xd
	fmul	st(0),st(2)
	fiadd	Xa
	fmul	st(0),st(1)
	fiadd	i160
	fimul	iFix1
	fistp	dword ptr [di+4]

	fild	Yd
	fmul	st(0),st(2)
	fiadd	Ya
	fmul	st(0),st(1)
	fisubr	i100
	fimul	iFix1
	fistp	dword ptr [di]

	fstp	tmpf
;	ffree	st(0)
;	fincstp

	fld	dword ptr [si+bp]
	fsub	dword ptr [si+bx]

	fld	dword ptr [si+bp+4*YGRID*ZGRID]
	fsub	dword ptr [si+bx+4*YGRID*ZGRID]
	fsub	st(0),st(1)
	fmul	st(0),st(2)
	fadd	dword ptr [si+bx+4*YGRID*ZGRID]
	fsub	dword ptr [si+bx]
	fstp	nX
	fld	dword ptr [si+bp+4*ZGRID]
	fsub	dword ptr [si+bx+4*ZGRID]
	fsub	st(0),st(1)
	fmul	st(0),st(2)
	fadd	dword ptr [si+bx+4*ZGRID]
	fsub	dword ptr [si+bx]
	fstp	nY
	fld	dword ptr [si+bp+4]
	fsub	dword ptr [si+bx+4]
	fsub	st(0),st(1)
	fmul	st(0),st(2)
	fadd	dword ptr [si+bx+4]
	fsub	dword ptr [si+bx]
	fstp	nZ

	fstp	tmpf
	fstp	tmpf
;	ffree	st(1)
;	ffree	st(0)

	fld	nX
	fmul	st(0),st(0)
	fld	nY
	fmul	st(0),st(0)
	fld	nZ
	fmul	st(0),st(0)
	fadd
	fadd
	fsqrt
	fld1
	fdivr

	fld	nX
	fmul	st(0),st(1)
	fld1
	fadd
	fild	UVscale
	fmul
	fistp	dword ptr [di+8]

	fld	nY
	fmul	st(0),st(1)
	fld1
	fadd
	fild	UVscale
	fmul
	fistp	dword ptr [di+12]

;	fstp	tmpf
	ffree	st(0)

no_interpolate:
	add	di,32
	ret
interpolate	endp

; ================== routine and marco for evaluating cubeindex

adjustindex	macro	v1,v2,v3
	mov	bp,4*(v1*YGRID*ZGRID+v2*ZGRID+v3)
	call	do_adjustindex
endm

do_adjustindex	proc	near
	fld	dword ptr [si+bp]
	fcomp	fIsoLevel
	fstsw	ax
	sahf
	ja	lbl
	or	bx,cx
lbl:
	shl	cx,1
	ret
do_adjustindex	endp

; ================== calculates a field value added by one source

; si points to float (x,y,z) - field source position
calcBallValue	proc	near
	fild	iX
	fsub	dword ptr [si]
	fmul	st(0),st(0)
	fild	iY
	fsub	dword ptr [si+4]
	fmul	st(0),st(0)
	fild	iZ
	fsub	dword ptr [si+8]
	fmul	st(0),st(0)
	fadd
	fadd
	fld	fStep
	fmul	st(0),st(0)
	fmul
	fld1
	fdivr
	ret
calcBallValue	endp

; ================== add a vertex to a scene

find_match	proc	near
	push	bx
	mov	bx,[si]
	add	bx,[si+4]
	shr	bx,6		; hash table is 1024 items large
next_collision:
	mov	di,hashtable[bx]
	inc	di
	jz	match_notfound
	dec	di
	mov	cl,8
	push	si di
	add	di,offset verts
	rep	cmpsw
	pop	di si
	jz	match_found
	add	bx,HASHDELTA	; do a collision slide
	and	bx,03FFh
	jmp	next_collision

match_notfound:
	mov	ax,numVerts
	inc	numVerts
	mov	di,ax
	shl	di,5
	mov	hashtable[bx],di
	mov	cl,8
	add	di,offset verts
	rep	movsw
	sub	si,8
	movsd
	movsd
	pop	bx
	ret

match_found:
	add	si,16		; add_vertex needs this to find out z
	mov	ax,di
	shr	ax,5
	pop	bx
	ret
find_match	endp

; this routine has to save si, bx, bp
add_vertex	proc	near
	push	si
	xor	dh,dh
	shl	dx,5
	add	dx,offset vertlist
	mov	si,dx
	call	find_match
	mov	edx,[si]
	add	[bp],edx
	pop	si
	mov	[si],ax		; put this vertex number to a facelist
	inc	si
	inc	si
	ret
add_vertex	endp

; ================== isosurface generation and rendering

frameMetaballs		proc	near
	push	cs		; prepare hash table for a next round
	pop	es
	mov	ax,0FFFFh
	mov	cx,1024
	mov	di,offset hashtable
	rep	stosw


;	fild	frame		; change field source positions
;	fldpi
;	fmul
;	fidiv	i1800
; 	fsin
;	fld	fIsoAmp
;	fmul	st(0),st(1)
;	fadd	fIsoBase
;	fstp	fIsoLevel

	fild	frame
	fmul	fPi180
 	fsin

; 	fld	i60
	fild	i3
	fmul	st(0),st(1)
	fstp	ball1x
; 	fld	i40
;	fmul	st(0),st(1)
	fld	st(0)
	fadd	st(0),st(0)
	fstp	ball1z
; 	fld	i50
	fld	f25
	fmul	st(0),st(1)
	fst	ball2y
	fstp	ball2z

	fild	frame
	fmul	fPi180
 	fcos

; 	fld	i40
;	fmul	st(0),st(1)
	fld	st(0)
	fadd	st(0),st(0)
	fstp	ball1y
;	fld	i60
	fild	i3
	fmul	st(0),st(1)
	fstp	ball2x
; 	fld	i80
 	fild	i4
	fmul	st(0),st(1)
	fstp	ball3x

	fmul
	fadd	st(0),st(0)
;	fmul	i50
	fmul	f25
	fst	ball3y
	fstp	ball3z

	mov	di,offset grid	; calculate field values on a grid
	mov	ax,-XGRID2
grid_calc_x:
	mov	bx,-YGRID2
grid_calc_y:
	mov	cx,-ZGRID2
grid_calc_z:
	mov	iX,ax
	mov	iY,bx
	mov	iZ,cx

	mov	si,offset ball1
	call	calcBallValue
	mov	si,offset ball2
	call	calcBallValue
	fadd
	mov	si,offset ball3
	call	calcBallValue
	fadd
	fstp	dword ptr [di]

	add	di,4
	inc	cx
	cmp	cx,ZGRID2+1
	jne	grid_calc_z
	inc	bx
	cmp	bx,YGRID2+1
	jne	grid_calc_y
	inc	ax
	cmp	ax,XGRID2+1
	jne	grid_calc_x

	xor	ax,ax
	mov	numFaces,ax
	mov	numVerts,ax

	mov	si,offset grid	; now polygonise that isosurface
	mov	ax,-XGRID2
grid_x:
	mov	bx,-YGRID2
grid_y:
	mov	cx,-ZGRID2
grid_z:
	mov	iX,ax
	mov	iY,bx
	mov	iZ,cx
	pusha

	xor	bx,bx
	mov	cx,1
	adjustindex	0, 0, 0
	adjustindex	1, 0, 0
	adjustindex	1, 1, 0
	adjustindex	0, 1, 0
	adjustindex	0, 0, 1
	adjustindex	1, 0, 1
	adjustindex	1, 1, 1
	adjustindex	0, 1, 1

	or	bl,bl
	jz	end_cell
	cmp	bl,0FFh
	je	end_cell

;	shl	bx,1
;	mov	ax,edgeTable[bx]
	mov	ax,0ffffh
;	or	ax,ax
;	jz	end_cell

	mov	di,offset vertlist
	push	bx

	interp	0, 0, 0, 1, 0, 0, 000100b
	interp	1, 0, 0, 1, 1, 0, 100110b
	interp	1, 1, 0, 0, 1, 0, 110010b
	interp	0, 1, 0, 0, 0, 0, 010000b
	interp	0, 0, 1, 1, 0, 1, 001101b
	interp	1, 0, 1, 1, 1, 1, 101111b
	interp	1, 1, 1, 0, 1, 1, 111011b
	interp	0, 1, 1, 0, 0, 1, 011001b
	interp	0, 0, 0, 0, 0, 1, 000001b
	interp	1, 0, 0, 1, 0, 1, 100101b
	interp	1, 1, 0, 1, 1, 1, 110111b
	interp	0, 1, 0, 0, 1, 1, 010011b

	pop	bx
	shl	bx,4
	add	bx,offset triTable
;	mov	ax,scene
;	mov	es,ax
;	mov	di,numVerts
;	shl	di,4
	mov	si,offset faces
	mov	bp,numFaces
	shl	bp,1
	add	si,bp
	shl	bp,1
	add	si,bp
	add	bp,offset face_z
	xor	ch,ch
add_face:
	mov	al,[bx]
	cmp	al,0Fh
	je	add_face_done

	mov	dword ptr [bp],0	; preload face z value
	mov	dl,[bx]
	call	add_vertex
	mov	dl,[bx+1]
	call	add_vertex
	mov	dl,[bx+2]
	call	add_vertex

	add	bx,3
	add	bp,4
	inc	numFaces
	jmp	add_face
add_face_done:

end_cell:
	popa
	add	si,4

	inc	cx
	cmp	cx,ZGRID2
	jne	grid_z
	add	si,4

	inc	bx
	cmp	bx,YGRID2
	jne	grid_y
	add	si,4*ZGRID

	inc	ax
	cmp	ax,XGRID2-1
	jne	grid_x

	call	drawMesh		; render isosurface
	mov	si,offset m_meta
	call	printStrBeg
	ret
frameMetaballs		endp